package l14_reflection;

import java.lang.reflect.Field;
import java.lang.reflect.Method;

class FieldTest {
	public static void main (String[] args) {
		try {
			testFields();
		} catch(ReflectiveOperationException e) {
			e.printStackTrace();
		}
	}

	private static void testFields () throws ReflectiveOperationException {
		CustomInt customInt = new CustomInt(8);

		//	Through reflection, we can access the private variables and methods
		//	of a class with the help of its class object and invoke the method
		//	by using the object. We use two methods for this purpose.

		//	Class.getDeclaredField(FieldName) : Used to get the private field.
		//	Returns an object of type Field for specified field name.

		//	Field.setAccessible(true) : Allows to access the field irrespective
		//	of the access modifier used with the field.

		Field field = CustomInt.class.getDeclaredField("value");
		field.setAccessible(true);
		System.out.println(STR."The field type is: \{field.getType()}");
		System.out.println(STR."The field value before set(): \{customInt}");
		field.set(customInt, 10);
		System.out.println(STR."The field value after set(): \{customInt}");
		System.out.println();

		Method method = CustomInt.class.getDeclaredMethod("private_function", String.class);
		method.setAccessible(true);
		method.invoke(customInt, "I am private");
	}
}

