package l14_reflection;

import java.lang.invoke.MethodHandle;
import java.lang.invoke.MethodHandles;
import java.lang.invoke.MethodHandles.Lookup;
import java.lang.invoke.MethodType;

public class MethodHandlesTest {

	public static void main(String ... args) {
		try {
			handleTest();
		} catch (Throwable e) {
			e.printStackTrace();
		}
	}

	private static void handleTest() throws Throwable {

		Lookup lookup = MethodHandles.lookup();	//	get lookup
		CustomInt customInt = new CustomInt(123);

		MethodHandle methodHandle = lookup.findVirtual(CustomInt.class, "toString",
			MethodType.methodType(String.class));
		System.out.println(methodHandle.invoke(customInt));
		System.out.println();

		methodHandle = lookup.findVirtual(CustomInt.class, "add",
			MethodType.methodType(int.class, CustomInt.class));
		System.out.println(methodHandle.invoke(customInt, new CustomInt(345)));
	}
}

